package {{package}}

import play.api.Logger
import play.api.mvc.{AbstractController, ControllerComponents}

import java.util.concurrent.CompletionException
import scala.concurrent.ExecutionContext
import scala.jdk.FutureConverters.CompletionStageOps

{{> generated}}
abstract class {{type}}(cc: ControllerComponents)
    extends AbstractController(cc) {
  implicit val ec: ExecutionContext = cc.executionContext
  protected val log = Logger(classOf[{{type}}])

{{#methods}}
  protected def {{name}}(
{{#parameters}}    {{> parameter}}{{/parameters}}
    {{#body}}, request: {{type}}{{/body}}
  ):Future[Status]
  def {{name}}:Action[AnyContent] = Action.async { req =>
    {{#body}}val json = req.body.asJson.get
    val body = json.as[{{type}}]
    {{/body}}
{{#queries}}val {{name}} = req.getQueryString("{{name}}")
    {{/queries}}
{{#headers}}val {{name}} = req.headers.get("{{name}}")
    {{/headers}}
    {{name}}(
      {{#parameters}}{{name}}{{^last}}, {{/last}}{{/parameters}}
      {{#body}}, body{{/body}}
    )
  }

{{/methods}}

}
